using System;
using System.Collections.Generic;
using System.Data;
using System.Web.UI;
using Ramms.Entity;
using Ramms.Services;
using Syncfusion.Grouping;
using Syncfusion.Web.UI.WebControls.Grid.Grouping;
using System.Web.UI.WebControls;

public partial class DetailedVoyageRiskCalculation : System.Web.UI.Page
{
    private IList<Ports> portList;
    private IList<CatCargo> cargoList;
    private string messageText;
    private int startPortindex;
    private int endtPortIndex;
    protected void Page_Load(object sender, EventArgs e)
    {
        lblErrorMessage.Visible = false;

        IVoyageRiskComputationService service = new VoyageRiskComputationService();

        if (!IsPostBack)
        {
            DataTable dt;
            dt = new DataTable();
            DataColumn dc1 = new DataColumn("StartPortName", Type.GetType("System.String"));
            //dc1.ColumnName = "StartPortName";
            DataColumn dc2 = new DataColumn("EndPortName", Type.GetType("System.String"));
            DataColumn dc3 = new DataColumn("StartAreaName", Type.GetType("System.String"));
            DataColumn dc4 = new DataColumn("EndAreaName", Type.GetType("System.String"));
            DataColumn dc5 = new DataColumn("CatGradeMnemonic", Type.GetType("System.String"));
            DataColumn dc6 = new DataColumn("CargoTypeName", Type.GetType("System.String"));
            DataColumn dc7 = new DataColumn("ViaSuez", Type.GetType("System.Boolean"));
            DataColumn dc8 = new DataColumn("ViaPanama", Type.GetType("System.Boolean"));
            DataColumn dc9 = new DataColumn("VoyageDaysNum", Type.GetType("System.Int32"));

            dt.Columns.Add(dc1);
            dt.Columns.Add(dc2);
            dt.Columns.Add(dc3);
            dt.Columns.Add(dc4);
            dt.Columns.Add(dc5);
            dt.Columns.Add(dc6);
            dt.Columns.Add(dc7);
            dt.Columns.Add(dc8);
            dt.Columns.Add(dc9);
            
            gdgpVoyageDetails.DataSource = dt;

            //Retrieivng CargoTypes
            cargoList = service.GetCatCargoNames();
            
            //Retrieving Ports Information
            portList = service.GetPorts();
            Session["portList"] = portList;
        }
        else
        {
            portList = (IList<Ports>) Session["portList"];
        }

        //gdgpVoyageDetails.CurrentRecordContextChange += new CurrentRecordContextChangeEventHandler(gdgpVoyageDetails_CurrentRecordContextChange);
     }


    protected void gdgpVoyageDetails_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
    {
        //Look for the RecordField and AlternateField Cell.
        if (e.TableCellIdentity.TableCellType == GridTableCellType.RecordFieldCell ||
            e.TableCellIdentity.TableCellType == GridTableCellType.AlternateRecordFieldCell || 
            e.TableCellIdentity.TableCellType == GridTableCellType.AddNewRecordFieldCell)
        {
            //Look for the Column Name "StartPortName" in the GridGroupingControl when it get rendered
            if (e.TableCellIdentity.Column.Name == "StartPortName")
            {
                //Changes the EditItem template of the column specified as DropDownListBox 
                DropDownList dropdownstartPort = new DropDownList();
                dropdownstartPort.DataSource = portList;
                dropdownstartPort.DataValueField = "CatPortId";
                dropdownstartPort.DataTextField = "PortName";
                dropdownstartPort.Width = 200;
                dropdownstartPort.ID = "dropdownstartPort";
                dropdownstartPort.DataBind();
                dropdownstartPort.SelectedIndex = startPortindex;   
                dropdownstartPort.AutoPostBack = true;
                
                //Adding the Event to the Combo Box
                dropdownstartPort.SelectedIndexChanged += new EventHandler(dropdownstartPort_SelectedIndexChanged);

                //Here we adding the DropDownListBox programatically using ITemplate Interface
                TemplateClass mytemp1 = new TemplateClass(dropdownstartPort);
                e.TableCellIdentity.Column.EditItemTemplate = mytemp1;
            }

            if (e.TableCellIdentity.Column.Name == "EndPortName")
            {
                //Changes the EditItem template of the column specified as DropDownListBox 
                DropDownList dropdownendPort = new DropDownList();
                dropdownendPort.DataSource = portList;
                dropdownendPort.DataValueField = "CatPortId";
                dropdownendPort.DataTextField = "PortName";
                dropdownendPort.ID = "dropdownendPort";
                dropdownendPort.Width = 200; 
                dropdownendPort.DataBind();
                dropdownendPort.SelectedIndex = endtPortIndex;  
                dropdownendPort.AutoPostBack = true;

                //Adding the Event to the Combo Box
                dropdownendPort.SelectedIndexChanged += new EventHandler(dropdownendPort_SelectedIndexChanged);

                //Here we adding the DropDownListBox programatically using ITemplate Interface
                TemplateClass mytemp2 = new TemplateClass(dropdownendPort);
                e.TableCellIdentity.Column.EditItemTemplate = mytemp2;
            }

            if (e.TableCellIdentity.Column.Name == "ViaSuez")
            {
                //Changes the EditItem template of the column specified as checkbox 
                CheckBox chkViaSuez = new CheckBox();

                //Here we adding the DropDownListBox programatically using ITemplate Interface
                TemplateClass mytemp = new TemplateClass(chkViaSuez);
                e.TableCellIdentity.Column.EditItemTemplate = mytemp;
            }

            if (e.TableCellIdentity.Column.Name == "ViaPanama")
            {
                //Changes the EditItem template of the column specified as checkbox 
                CheckBox chkViaPanama = new CheckBox();

                //Here we adding the DropDownListBox programatically using ITemplate Interface
                TemplateClass mytemp = new TemplateClass(chkViaPanama);
                e.TableCellIdentity.Column.EditItemTemplate = mytemp;
            }

        }
    }

    public void dropdownstartPort_SelectedIndexChanged(object sender, EventArgs e)
    {
        DropDownList dropdown = (DropDownList) sender;
        //To assign corresponding AreaName in the column2 Start Area
        GridTableCellStyleInfo style;
        style = gdgpVoyageDetails.TableDescriptor.Columns[1].Appearance.AnyRecordFieldCell;
        style.CellValue = portList[dropdown.SelectedIndex].GeographicalArea.AreaName;
        startPortindex = dropdown.SelectedIndex;
        //lblErrorMessage.Text = "SeletedIndexChange Event of the DropDownList has been fired";
    }

    public void dropdownendPort_SelectedIndexChanged(object sender, EventArgs e)
    {
        DropDownList dropdown = (DropDownList)sender;
       
        //To assign corresponding AreaName in the column4 Start Area
        GridTableCellStyleInfo style;
        style = gdgpVoyageDetails.TableDescriptor.Columns[3].Appearance.AnyRecordFieldCell;
        style.CellValue  = portList[dropdown.SelectedIndex].GeographicalArea.AreaName;
        style.Text = portList[dropdown.SelectedIndex].GeographicalArea.AreaName;
        endtPortIndex = dropdown.SelectedIndex; 
    }

    /*void gdgpVoyageDetails_CurrentRecordContextChange(object sender, CurrentRecordContextChangeEventArgs e)
    {

        if (gdgpVoyageDetails.Enabled)
        {
            if (e.Action == CurrentRecordAction.EnterRecordCalled)
            {
                GridTableCellStyleInfo style;
                style =gdgpVoyageDetails.TableDescriptor.Columns[0].Appearance.AnyRecordFieldCell;
                style.DataSource = portList;
                style.ValueMember = "CatPortId";
                style.DisplayMember = "PortName";
                style.CellType = "ComboBox";
                
                TemplateClass mytemp = new TemplateClass(dropdown);
                    e.TableCellIdentity.Column.EditItemTemplate = mytemp;\
     
                //style.Changed +=new Syncfusion.Styles.StyleChangedEventHandler(style_Changed);     
                //gdgpVoyageDetails.TableDescriptor.Columns[0].Appearance.AnyRecordFieldCell.Changed +=new StyleChangedEventHandler(AnyRecordFieldCell_Changed);
  
                style = gdgpVoyageDetails.TableDescriptor.Columns[2].Appearance.AnyRecordFieldCell;
                style.DataSource = portList;
                style.ValueMember = "CatPortId";
                style.DisplayMember = "PortName";
                style.CellType = "ComboBox";

                style = gdgpVoyageDetails.TableDescriptor.Columns[4].Appearance.AnyRecordFieldCell;
                style.DataSource = cargoList;
                style.ValueMember = "CargoId";
                style.DisplayMember = "GradeMnemonic";
                style.CellType = "ComboBox";

                style = gdgpVoyageDetails.TableDescriptor.Columns[6].Appearance.AnyRecordFieldCell;
                style.CellType = "CheckBox";

                style = gdgpVoyageDetails.TableDescriptor.Columns[7].Appearance.AnyRecordFieldCell;
                style.CellType = "CheckBox";
                
               
                //gdgpVoyageDetails.Engine.CreateRecord(gdgpVoyageDetails.Table);
            }
            
            if( e.Action ==CurrentRecordAction.EndEditCalled)
            {
                DataRow dr = dt.NewRow();
                dr= (DataRow) e.Record.GetData();
                dt.AcceptChanges();
            }
        }
    } */

   
    protected void btnGenerate_Click(object sender, EventArgs e)
    {
       messageText = "";
     /*  Validations();
       if (messageText.Trim().Length > 0)
       {
           lblErrorMessage.Visible = true;
           lblErrorMessage.Text = messageText;
       }
       else
       {
           int voyageLegsCount;
           voyageLegsCount = 1;
           VoyageData voyageData = new VoyageData();
           DetailedVoyageLegsData[] detailedVoyageLegsData = new DetailedVoyageLegsData[voyageLegsCount];

           voyageData.VesselDeadWeight = Convert.ToInt32(txtVesselDwt.Text);
           voyageData.TCEquivalent = Convert.ToDecimal(txtTcEquivalent.Text);

           voyageData.VoyCalcSeq = Convert.ToInt32(txtVoyageSequence.Text.Trim() == null ? "12345" : txtVoyageSequence.Text);
           voyageData.VesselImoNumber = Convert.ToInt32(txtVesselImoNum.Text.Trim() == null ? "12345" : txtVesselImoNum.Text);
           voyageData.FixtureNumberString = txtFixtureNumber.Text.Trim() == null ? "12345" : txtFixtureNumber.Text;
           voyageData.BenchCode = txtBenchCode.Text.Trim() == null ? "12345" : txtBenchCode.Text;
           voyageData.VesselName = txtVesselName.Text.Trim() == null ? "12345" : voyageData.VesselName;
           voyageData.UserId = "Test";
           voyageData.IsBPVessel = chkBpVessel.Checked;
       }*/
    }

     protected void Validations()
     {
        ErrorMessage(txtTcEquivalent, "Tc Equivalent");
        ErrorMessage(txtVesselDwt, "Vessel Dead Weight");
     } 


    private void ErrorMessage(TextBox txtControl, String txtName)
    {
        if (txtControl.Text.Trim().Length == 0)
        {
            messageText = messageText + txtName + " is Mandatory ! ";
        }
    }

    public class TemplateClass : ITemplate
    {
        private Control m_ctrlChildControl = null;
        public TemplateClass(Control ctrlChildControl)
        {
            m_ctrlChildControl = ctrlChildControl;
        }

        public void InstantiateIn(Control container)
        {
            container.Controls.Add(m_ctrlChildControl);
        }
    }
}
